﻿using System;
using System.Threading.Tasks;
using Atlassian.Jira.Linq;

namespace ConsoleApp1
{
    // Install-Package Atlassian.SDK
    // Install-Package OpenSSL.PrivateKeyDecoder
    class Program
    {
        static async Task Main(string[] args)
        {
            var privateKey = "-----BEGIN PRIVATE KEY-----MI...[생략]...x3/-----END PRIVATE KEY-----"; // <- get your private key in here
            var decoder = new OpenSSL.PrivateKeyDecoder.OpenSSLPrivateKeyDecoder();
            var keyInfo = decoder.Decode(privateKey);
            var consumerSecret = OpenSSL.PrivateKeyDecoder.RSAExtensions.ToXmlString(keyInfo, true);

            // Console.WriteLine(keyInfo);
            // Console.WriteLine(consumerSecret);

            string consumerKey = "...[생략]...";
            string accessToken = "...[생략]...";
            string accessTokenSecret = "...[생략]...";

            // System.ApplicationException: Using query parameters in the base URL is not supported for OAuth calls. Consider using AddDefaultQueryParameter instead.
            //var client = Atlassian.Jira.Jira.CreateRestClient("http://...JIRA 기본 주소...");
            //client.RestClient.RestSharpClient.Authenticator =
            //    RestSharp.Authenticators.OAuth1Authenticator.ForProtectedResource(
            //        consumerKey,        // <- fill it
            //        consumerSecret,     // <- generated
            //        accessToken,        // <- fill it
            //        accessTokenSecret,  // <- fill it
            //        RestSharp.Authenticators.OAuth.OAuthSignatureMethod.RsaSha1
            //    );

            var client = Atlassian.Jira.Jira.CreateOAuthRestClient("http://...JIRA 기본 주소...",
                consumerKey,        // <- fill it
                consumerSecret,     // <- generated
                accessToken,        // <- fill it
                accessTokenSecret  // <- fill it
                );

            var issue = await client.Issues.GetIssueAsync("...issue-number...");

            Console.WriteLine(issue.Summary);
        }
    }
}
